<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Vue Router</title>
</head>
<body>
    <div id="app">
        <router-link to="/halaman1">Halaman 1</router-link>
        <router-link to="/halaman2">Halaman 2</router-link>
        <router-link to="/halaman3">Halaman 3</router-link>
        <router-view></router-view>
    </div>

    <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
    <script src="https://unpkg.com/vue-router/dist/vue-router.js"></script>
    <script>
        let Halaman1 = {
            template: `<h2>Halaman ini yang bisa diakses oleh siapa saja</h2>`
        }

        let Halaman2 = {
            template: `<h2>Halaman ini yang bisa diakses untuk yang sudah Login</h2>`
        }

        let Halaman3 = {
            template: `<h2>Halaman ini yang bisa diakses untuk yang sudah Login, dan Admin</h2>`
        }

        const routes = [
            {path: '/halaman1', name: 'Halaman1', component: Halaman1},
            {path: '/halaman2', name: 'Halaman2', component: Halaman2},
            {path: '/halaman3', name: 'Halaman3', component: Halaman3}
        ]

        const router = new VueRouter({
            routes
        })

        router.beforeEach((to, from, next) =>{
            isLogin = false,
            isAdmin = false
            if(to.name === 'Halaman2' && !isLogin){
                alert('Halaman ini hanya untuk yang sudah Login')
                next(false)
            }else if(to.name === 'Halaman3 || !isLogin && !isAdmin'){
                alert('Halaman ini hanya untuk Admin yang sudah Login')
                next(false)
            }else(
                next()
            )
        })

        var vm = new Vue({
            el: '#app',
            router,
            data: {}
        })
    </script>
</body>
</html>